function skjdemo2
% SKJDEMO1 demoaa signaalin suodattamista.
%
% Kytetn signaalina samaa kohinaista puhetta. 
% Esitelln suhinainen signaali ja suodatetaan sit niin,
% ett jljelle j lankapuhelimen kaista 300 .. 3400 Hz.

% Jukka Parviainen, parvi@hut.fi, 15.1.2002, 17.1.2001.
% Tiedostot saatavilla 
% http://www.cis.hut.fi/Opinnot/T-61.140/  -> Vinkkej ja linkkej

% Alkutoimenpiteet: tarkista ett esityskoneessasi on 
% kaiuittimet tai salin kyseess ollen audioliitnt.
% Kutista Matlab-tyikkuna suhteellisen pieneksi ruudun alareunaan,
% sijoita piirtoikkuna, esimerkiksi ensimmisen vaiheen jlkeen,
% sopivaan paikkaan, ett se nkyy.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all;      % sulkee kaikki ikkunat
clc;            % puhdistaa ruudun

fprintf(1,'****************************************\n');
fprintf(1,'****************************************\n');
fprintf(1,'************  SKJDEMO2.m  **************\n');
fprintf(1,'****************************************\n');
fprintf(1,'** Ajaako Hill maailmanmestaruudesta? **\n');
fprintf(1,'************    osa II    **************\n');
fprintf(1,'****************************************\n');
fprintf(1,'\n\n');

fprintf(1,'** Odota hetki...\n\n');

% Luetaan nisignaali sisn Matlabiin
[y, fs, nbits] = wavread('skjdemo1.wav'); 

Wp = 2*2800/fs;
Ws = 2*3300/fs;
Rp = 0.2;
Rs = 40;
[N,Wn] = ellipord(Wp, Ws, Rp, Rs);
[b,a] = ellip(N, Rp, Rs, Wn);
[hh,ww]=freqz(b,a,1024,fs);   % suotimen amplitudi- ja vaihevaste

ysuod = filter(b,a,y);  

Ysuod = fft(ysuod,2^14);

fprintf(1,'** Paina ENTER...\n\n');
pause;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

fprintf(1,'Kuunnellaan DEMO1:n suhinaista nt.\n\n');

t = linspace(0, length(y)/fs, length(y));

soundsc(y, fs);  %Kuunnellaan

fprintf(1,'** Paina ENTER nen kuuntelun jlkeen...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

Y = fft(y,2^14); % Lyhyt ptk, jotta ei vie liikaa aikaa...

w = linspace(0, fs, length(Y));
subplot(311);
plot(w, abs(Y));
axis([0 fs/2 0 1.1*max(abs(Y))]);
grid on;
title(['Signaalin spektri 0..' num2str(fs/2) ' hertzi']);
xlabel('taajuus (Hz)');

fprintf(1,'Spektriss on esitetty signaali taajuuskomponenttien avulla.\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

fprintf(1,'ness on paljon suhinaa.\n\n');

fprintf(1,'Tehdn alipstsuodin, joka pst lpi\n vain lankapuhelintaajuudet.\n\n');
fprintf(1,'Aikatason nopeat muutokset signaalissa\n vastaavat korkeita taajuuksia.\n');
fprintf(1,'Aikatason hitaat muutokset ovat matalia taajuuksia.\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% Seuraava pelkk pluffia
h = waitbar(0,'Lasketaan suotimen kertoimia...');
for i=1:20,
  pause(0.02);
  waitbar(i/20,h)
end
close(h)

subplot(312);
ku = plot(ww,abs(hh).^2);
axis([0 ww(end) 0 1.05]);
set(ku,'LineWidth',2);
grid on;
title('Elliptinen alipstsuodin H(z)');
subplot(311); xlabel('');
subplot(312); xlabel('taajuus (Hz)');

fprintf(1,'Toteutettiin elliptinen alipstsuodin (kesk.).\n');
fprintf(1,'Tm suodin ksittelee signaalia niin, \n');
fprintf(1,'ett matalat taajuudet jvt jljelle\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

fprintf(1,'Suodatetaan suhinainen signaali...\n\n');

% Aikatason konvoluutio!
%fprintf(1,'\n');
%fprintf(1,'                 --------------\n');
%fprintf(1,'                 |            |\n');
%fprintf(1,'      x[n] ----> |    h[n]    | ---->  y[n] = h[n] * x[n]\n');
%fprintf(1,'                 |            |\n');
%fprintf(1,'                 --------------\n');
%fprintf(1,'\n');
% Taajuustason kertolasku!
% Pitisk tm taajuuskuva jtt pois?
fprintf(1,'\n');
fprintf(1,'                 --------------\n');
fprintf(1,'                 |            |\n');
fprintf(1,'  X(e^jw)  ----> |  H(e^jw)   | ---->  Y(e^jw) = H(e^jw) . X(e^jw)\n');
fprintf(1,'                 |            |\n');
fprintf(1,'                 --------------\n');
fprintf(1,'\n');
fprintf(1,'\n');

% Seuraavalla komennolla suodatetaan "skjdemo1" alipstsuotimella
% ysuod = filter(b,a,y);  

% Seuraava pelkk pluffia
h = waitbar(0,'Suodatetaan...');
for i=1:40,
  pause(0.03);
  waitbar(i/40,h)
end
close(h)

% Ysuod = fft(ysuod,2^14);
w = linspace(0, fs, length(Ysuod));
subplot(313);
plot(w, abs(Ysuod));
grid on;
axis([0 fs/2 0 1.1*max(abs(Y))]);
title('Suodatetun signaalin spektri');
subplot(312), xlabel('');
subplot(313), xlabel('taajuus (Hz)');

fprintf(1,'Kuunnellaan seuraavaksi suodatettu ni.\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

soundsc(ysuod,fs);

fprintf(1,'Kuulostaako suodatettu signaali "paremmalta"?\n\n');

fprintf(1,'** Paina ENTER nen kuuntelun jlkeen...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Mit on tapahtunut aikatasossa?!

clc

fprintf(1,'Piirretn viel alkuperinen ja suodatettu\n');
fprintf(1,'signaali aikatasoon\n\n');

clf;
plot(t(15000:15300), y(15000:15300));  
hold on;
ku3 = plot(t(15000:15300), ysuod(15000:15300), 'r');
set(ku3,'LineWidth',2);
title('Alkuperinen ja suodatettu signaali x(t)');
xlabel('aika (sekunnit)');
ylabel('voimakkuus');
legend({'Alkuperinen','Suodatettu'});
grid on;
axis([t(15000) t(15300) 1.1*min(y(15000:15300)) 1.1*max(y(15000:15300))]);


fprintf(1,'** LOPPU. Paina ENTER.\n\n');
pause;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

