function skjdemo3
% SKJDEMO3 demoaa signaalin jaksollisuutta.
%
% Kytetn signaalina jaksollista nnett.

% Jukka Parviainen, parvi@hut.fi, 15.1.2002, 17.1.2001.
% Tiedostot saatavilla 
% http://www.cis.hut.fi/Opinnot/T-61.140/  -> Vinkkej ja linkkej

% Alkutoimenpiteet: tarkista ett esityskoneessasi on 
% kaiuittimet tai salin kyseess ollen audioliitnt.
% Kutista Matlab-tyikkuna suhteellisen pieneksi ruudun alareunaan,
% sijoita piirtoikkuna, esimerkiksi ensimmisen vaiheen jlkeen,
% sopivaan paikkaan, ett se nkyy.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all;      % sulkee kaikki ikkunat
clc;            % puhdistaa ruudun

fprintf(1,'****************************************\n');
fprintf(1,'****************************************\n');
fprintf(1,'************  SKJDEMO3.m  **************\n');
fprintf(1,'****************************************\n');
fprintf(1,'*******  Jaksolliset signaalit  ********\n');
fprintf(1,'**************  Sampsa  ****************\n');
fprintf(1,'****************************************\n');
fprintf(1,'\n\n');

[y, fs, nbits] = wavread('skjdemo3.wav');
y = y - mean(y);

yF = fft(y);  % silmnlumetta, ett tll!



fprintf(1,'Kuultava ni on tutkija\n Sampsa Laineen lahja maailmalle...\n\n');

fprintf(1,'Vokaalinne on nauhoitettu ja\n saatettu digitaaliseen muotoon\n\n');

fprintf(1,'Aloitetaan kuuntelemalla nt.\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

soundsc(y, fs);

fprintf(1,'** Paina ENTER...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;
 
fprintf(1,'Piirretn nisignaali x(t).\n\n');

pituus_sek = length(y)/fs;
t = linspace(0, pituus_sek, length(y));
plot(t,y);
title('Vokaalinne');
xlabel('Aika (sekunnit)');
ylabel('Voimakkuus');
axis([0 t(end) 1.1*min(y) 1.1*max(y)]);
% Nytt varsin sekavalta - otetaan pieni nyte kymmenysosasekunnin 
% ajalta:
fprintf(1,'Nytt varsin sekavalta - otetaan lyhyt nyte vlist...\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

plot(t(1:4410),y(1:4410));
grid on;
title('Vokaalinne, t = 0..0.1 sek');
xlabel('aika (sekunnit)');
ylabel('voimakkuus');
% Signaali nytt lhes periodiselta eli x(t) = x(t+T). 
% Mik on sen "jaksonpituus" T?
fprintf(1,'Signaali nytt lhes periodiselta eli x(t) = x(t+T).\n');
fprintf(1,'Mik on sen "jaksonpituus" T?\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

% Taajuustasoon fourier-muuntamalla ja sen spektri:
fprintf(1,'Signaaleja kannattaa tutkia niin aika- kuin taajuustasossa.\n');
fprintf(1,'Taajuustason tutkimiseen Fourier-muunnos on oiva tykalu.\n\n');

fprintf(1,'Lasketaan siis seuraavaksi signaalin Fourier-muunnos.\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

% Seuraava pelkk pluffia
h = waitbar(0,'Lasketaan Fourier-muunnosta...');
for i=1:20,
  pause(0.03);
  waitbar(i/20,h)
end
close(h)

hz = linspace(0,fs, length(yF));
plot(hz, abs(yF));
axis([0 4000 0 1.1*max(abs(yF))]);
grid on;
title('Vokaalinne, spektri f = 0..4000 Hz');
xlabel('Taajuus (hertz eli 1/s)');
ylabel('Voimakkuus');
fprintf(1,'Signaalin jaksollisuus nkyy nyt piikkein spektriss!\n\n');
fprintf(1,'Arvioi ensimmisen piikin taajuus (perustaajuus)\n');
fprintf(1,'ja vertaa sit yll laskemaasi jaksonpituuteen T!\n\n');

fprintf(1,'** Paina ENTER...\n\n');
pause;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc;

fprintf(1,'Mik merkitys harmonisilla komponenteilla on?\n\n');

fprintf(1,'** LOPPU. Jatka demoon SKJDEMO4.m \n\n');

